


module EST

  class Mailset

    private

    def construct_menu

      mrc = CORE.ifrc['menu']
      @menubar             = Gtk::MenuBar.new
      @topbox.pack_start( @menubar, true, true, 0 )
        @item_move         = Gtk::MenuItem.new( mrc['move'] )
        @menumove          = Gtk::Menu.new
        @menubar.append @item_move
        @item_move.set_submenu @menumove

        @item_trash        = Gtk::MenuItem.new( mrc['trash'] )
        @menubar.append @item_trash
 
if false
        @item_mbox         = Gtk::MenuItem.new( mrc['mbox'] )
        @menubar.append @item_mbox
        @menumbox          = Gtk::Menu.new
        @item_mbox.set_submenu @menumbox
          @item_clear      = Gtk::MenuItem.new( mrc['clear'] )
          @menumbox.add @item_clear
          @item_update     = Gtk::MenuItem.new( mrc['update'] )
          @menumbox.add @item_update
end
          @item_ahead      = Gtk::MenuItem.new( '' )
          @item_back       = Gtk::MenuItem.new( '' )
          @item_next       = Gtk::MenuItem.new( '' )
          @item_prev       = Gtk::MenuItem.new( '' )
          @item_prevpage   = Gtk::MenuItem.new( '' )
          @item_nextpage   = Gtk::MenuItem.new( '' )

        @item_mail         = Gtk::MenuItem.new( mrc['mail'] )
        @menubar.append @item_mail
        @menumail          = Gtk::Menu.new
        @item_mail.set_submenu @menumail
          @item_reply      = Gtk::MenuItem.new( mrc['reply'] )
          @menumail.add @item_reply
          @item_write      = Gtk::MenuItem.new( mrc['write'] )
          @menumail.add @item_write
          @item_reedit     = Gtk::MenuItem.new( mrc['reedit'] )
          @menumail.add @item_reedit
          @item_fwd        = Gtk::MenuItem.new( mrc['forward'] )
          @menumail.add @item_fwd
          @item_clear      = Gtk::MenuItem.new( mrc['clear'] )
          @menumail.add @item_clear
          @item_update     = Gtk::MenuItem.new( mrc['update'] )
          @menumail.add @item_update

if false
        @item_addr         = Gtk::MenuItem.new( mrc['addr'] )
        @menubar.append @item_addr
        @menuaddr          = Gtk::Menu.new
        @item_addr.set_submenu @menuaddr
          @item_editaddr   = Gtk::MenuItem.new( mrc['editaddr'] )
          @menuaddr.add @item_editaddr
end

        @item_inet         = Gtk::MenuItem.new( mrc['inet'] )
        @menubar.append @item_inet
        @menuinet          = Gtk::Menu.new
        @item_inet.set_submenu @menuinet
          @item_pop        = Gtk::MenuItem.new( mrc['pop'] )
          @menuinet.add @item_pop
          @item_send       = Gtk::MenuItem.new( mrc['send'] )
          @menuinet.add @item_send

        @item_app          = Gtk::MenuItem.new( mrc['app'] )
        @menubar.append @item_app
        @menuapp           = Gtk::Menu.new
        @item_app.set_submenu @menuapp
          @item_editaddr   = Gtk::MenuItem.new( mrc['editaddr'] )
          @menuapp.add @item_editaddr
          @item_quit       = Gtk::MenuItem.new( mrc['quit'] )
          @menuapp.append @item_quit
          @item_quitf      = Gtk::MenuItem.new( mrc['quitf'] )
          @menuapp.append @item_quitf
if $DEBUG
        @item_gc = Gtk::MenuItem.new( 'GC' )
        @menubar.append @item_gc
        @item_gc.signal_connect( 'activate' ) do |w|
          GC.start
        end
end
    end


    def bind_menu_key
      @accel = Gtk::AccelGroup.new
      @accel.attach @win
      @accel.add( ?\ , 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_ahead, 'activate' )
      @accel.add( ?j, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_ahead, 'activate' )
      @accel.add( ?k, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_back, 'activate' )
      @accel.add( ?n, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_next, 'activate' )
      @accel.add( ?p, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_prev, 'activate' )
      @accel.add( ?f, Gdk::CONTROL_MASK, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_nextpage, 'activate' )
      @accel.add( ?b, Gdk::CONTROL_MASK, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_prevpage, 'activate' )
      @accel.add( ?w, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_write, 'activate' )
      @accel.add( ?a, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_reply, 'activate' )
      @accel.add( ?e, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_reedit, 'activate' )
      @accel.add( ?f, 0, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_fwd, 'activate' )
      @accel.add( ?q, Gdk::SHIFT_MASK, Gtk::AccelGroup::ACCEL_VISIBLE,
                  @item_quit, 'activate' )
    end


    def bind_menu_action
      @item_trash.signal_connect( 'activate' ) do |w|
        protect( 'move to trash' ){
          c = 0
          @current.each_selection do |idx|
            c += 1
            discard_mail( @current, idx )
          end
          case c
          when 0
            CORE.notice "no mail selected"
          when 1
            ;
          else
            CORE.notice "discard #{c} mails"
          end
        }
      end

      @item_update.signal_connect( 'activate' ) do |w|
        protect( 'update mbox' ){
          @current.update
        }
      end

      @item_clear.signal_connect( 'activate' ) do |w|
        protect( 'clear trash' ){
          s = CORE.mailbox.trash.size
          s.times{|c| CORE.mailbox.trash.remove 0 }
          CORE.notice "cleared #{s} mails from trash"
        }
      end

      @item_ahead.signal_connect( 'activate' ) do |w|
        protect( 'read ahead' ){
          unless @viewer.read_ahead then
            @current.select_next
          end
        }
      end

      @item_back.signal_connect( 'activate' ) do |w|
        protect( 'read back' ){
          unless @viewer.read_back then
            @current.select_prev
          end
        }
      end

      @item_next.signal_connect( 'activate' ) do |w|
        protect( 'view next' ){
          @current.select_next
        }
      end

      @item_prev.signal_connect( 'activate' ) do |w|
        protect( 'view prev' ){
          @current.select_prev
        }
      end

      @item_nextpage.signal_connect( 'activate' ) do |w|
        protect( 'next page' ){
          @clistadj.set_value @clistadj.value + @clistadj.page_size
        }
      end

      @item_prevpage.signal_connect( 'activate' ) do |w|
        protect( 'prev page' ){
          @clistadj.set_value @clistadj.value - @clistadj.page_size
        }
      end

      @item_write.signal_connect( 'activate' ) do |w|
        protect( 'write' ){
          CORE.edit CORE.composer.new_mail
          false
        }
      end

      @item_reply.signal_connect( 'activate' ) do |w|
        protect( 'reply' ){
          orig = @current[ @current.selected ]
          unless orig then
            CORE.notice "no mail selected to reply"
            break
          end
          CORE.edit CORE.composer.replyto( orig )
          false
        }
      end

      @item_reedit.signal_connect( 'activate' ) do |w|
        protect( 're edit' ){
          orig = @current[ @current.selected ]
          unless orig then
            CORE.notice "no mail selected to edit"
            break
          end
          CORE.edit orig
        }
      end

      @item_fwd.signal_connect( 'activate' ) do |w|
        protect( 'forward' ){
          orig = @current[ @current.selected ]
          unless orig then
            CORE.notice "no mail selected to forward"
            break
          end
          CORE.edit CORE.composer.forward( orig )
          false
        }
      end

      @item_send.signal_connect( 'activate' ) do |w|
        protect( 'send' ){
          CORE.sender.sendmail
          false
        }
      end

      @item_pop.signal_connect( 'activate' ) do |w|
        protect( 'pop' ){
        # Thread.fork do
          CORE.popper.load
        # end
          false
        }
      end

      @item_editaddr.signal_connect( 'activate' ) do |w|
        protect( 'edaddr' ){
          CORE.address_book.edit do |ret|
            if ret then
              CORE.notice 'editing address book was done.'
            else
              CORE.notice 'editing address book was canceled.'
            end
          end
          false
        }
      end

      @item_quit.signal_connect( 'activate' ) do |w|
        protect( 'shutdown' ){
          CORE.shutdown( false )
          false
        }
      end

      @item_quitf.signal_connect( 'activate' ) do |w|
        protect( 'shutdown (force)' ){
          CORE.shutdown( true )
          false
        }
      end
    end
  
  end

end
